diff -ur nagios-2.9.original/base/checks.c nagios-2.9/base/checks.c
--- nagios-2.9.original/base/checks.c	2007-10-26 14:54:46.000000000 +0100
+++ nagios-2.9/base/checks.c	2007-11-13 13:15:48.797195872 +0000
@@ -1212,9 +1212,12 @@
 
 				/* put service into a hard state without attempting check retries and don't send out notifications about it */
 				temp_service->host_problem_at_last_check=TRUE;
+				/* ALT2007-11-13: Altinity patch */
+				/* Reset current attempt only if it is currently in a soft state */
+				if(temp_service->state_type==SOFT_STATE)
+					temp_service->current_attempt=1;
 				temp_service->state_type=HARD_STATE;
 				temp_service->last_hard_state=temp_service->current_state;
-				temp_service->current_attempt=1;
 			        }
 
 			/* the host is up - it recovered since the last time the service was checked... */
@@ -1233,8 +1236,11 @@
 				/* ADDED IF STATEMENT 01-17-05 EG */
 				/* 01-17-05: Services in hard problem states before hosts went down would sometimes come back as soft problem states after */
 				/* the hosts recovered.  This caused problems, so hopefully this will fix it */
+				/* Altinity patch: Removed because this should be catered for in ALT2007-11-13 */
+				/*
 				if(temp_service->state_type==SOFT_STATE)
 					temp_service->current_attempt=1;
+				*/
 
 #ifdef REMOVED_041403
 				/* don't send a recovery notification if the service recovers at the next check */
@@ -1264,6 +1270,9 @@
 					if(hard_state_change==TRUE){
 						log_service_event(temp_service);
 						state_was_logged=TRUE;
+
+						/* Altinity patch: run the service event handler to handle the hard state caused by host */
+						handle_service_event(temp_service);
 					        }
 				        }
 
Binary files nagios-2.9.original/base/checks.o and nagios-2.9/base/checks.o differ
Binary files nagios-2.9.original/base/nagios and nagios-2.9/base/nagios differ
Only in nagios-2.9/base: nagios.2.9
